#include "Animation2D.h"
#include "OpenGL.h"
#include "ProfileCounter.h"

void Animation2D::Update(float dtime) {
	curtime+=dtime;
	while (curtime>spf) {
		if (++curFrame>=numFrames) curFrame=0;
		curtime-=spf;
	}
	int x=curFrame%numX;
	int y=curFrame/numX;
	strtX=(.5f + x*frmwidth) / 128;
	endX=strtX + (frmwidth-1) / 128;
	strtY=(.5f + y*frmheight) / 2048;
	endY=strtY + (frmheight-1) / 2048;
}

int Animation2D::Render() {
	MaterialManager::BindTexture(0, Texture);
	glBegin(GL_QUADS);
	glTexCoord2f(endX,endY); glVertex3f(width,0,0);
	glTexCoord2f(endX,strtY); glVertex3f(width,height,0);
	glTexCoord2f(strtX,strtY); glVertex3f(0,height,0);
	glTexCoord2f(strtX,endY); glVertex3f(0,0,0);
	glEnd();
	return 2;
}
