#ifndef COLLISION_INCLUDED
#define COLLISION_INCLUDED

#include "VectorX.h"

inline bool CollisionSphereEdge(Vector3& A, Vector3& V, 
									   Vector3& P, Vector3& ED, float r) {
	Vector3 N=V%ED;
	float d=N*(A-P);
	if (d>r) return 0;
	return 1;
}

inline float CollisionSpherePlane(Vector3& A, Vector3& V, Vector3& N,
										 Vector3& P, Vector3* C, Vector3* nV,
										 float r=0, float damp=1) {
	float s=N*V;	
	if (!s) return 0;	
	float d=N*(P-A);
	if (d<0) r=-r;	
	float t=(d-r)/s;	
	/*if (t>=1 || t<-2*r/s) return 0;
	if (t<0) return 1;*/
	if (t>=1 || t<0) return 0;
	if (C) *C=A+V*t;
	if (nV) *nV=(V.operator-(N*(2*s)))*damp;
	return 1-t;
}

#endif
