#define BEGINCOMMAND(x) class _Cmd##x :public Console::Command {public: \
						_Cmd##x () {Name=#x; Console::AddCommand(this);} \
						virtual void Execute(string* str) {

#define ENDCOMMAND(x) }} Cmd##x;


void Switch(bool& val, string name) {
	Console::Output(name+' ');
	Console::Output((val=!val) ? "enabled\n" : "disabled\n");
}

#include "ProfileCounter.h"
#include "ParticleSystem.h"
#include "JSFramework.h"

BEGINCOMMAND(wireframe)
Switch(Globals::Wireframe, "Wireframe");
ENDCOMMAND(wireframe)

BEGINCOMMAND(externalcam)
Switch(Globals::ExtCam, "External Camera");
ENDCOMMAND(externalcam)

BEGINCOMMAND(profiler)
Switch(ProfileCounter::Profiling, "Profiler");
ENDCOMMAND(profiler)

BEGINCOMMAND(drawquadtree)
Switch(Globals::ShowSpheres, "Quadtree drawing");
ENDCOMMAND(drawquadtree)

BEGINCOMMAND(drawboundingboxes)
Switch(Globals::ShowBoxes, "AABB drawing");
ENDCOMMAND(drawboundingboxes)

BEGINCOMMAND(autotype)
Switch(Console::AutoType, "Autotype");
ENDCOMMAND(autotype)

BEGINCOMMAND(drawfps)
Switch(Globals::DrawFps, "Fps");
ENDCOMMAND(drawfps)

BEGINCOMMAND(listcommands)
Console::ListCommands();
ENDCOMMAND(listcommands)

class _CmdCamSetViewDistance: public Console::Command {
public:
	_CmdCamSetViewDistance() {
		Name="camsetviewdistance";
		Params.push_back(Console::Param("fNear", Console::FLOAT));
		Params.push_back(Console::Param("fFar", Console::FLOAT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		JSApp::Camera.setViewDistance(atof(str[0].c_str()), atof(str[1].c_str()));
	}
} CmdSetViewDistance;

class _CmdCamSetFoV: public Console::Command {
public:
	_CmdCamSetFoV() {
		Name="camsetfov";
		Params.push_back(Console::Param("fFoV", Console::FLOAT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		JSApp::Camera.setFoV(atof(str[0].c_str()));
	}
} CmdCamSetFoV;

class _CmdCamRotate: public Console::Command {
public:
	_CmdCamRotate() {
		Name="camrotate";
		Params.push_back(Console::Param("fDegree", Console::FLOAT));
		Params.push_back(Console::Param("fAxisX", Console::FLOAT));
		Params.push_back(Console::Param("fAxisY", Console::FLOAT));
		Params.push_back(Console::Param("fAxisZ", Console::FLOAT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		JSApp::Camera.rotate(atof(str[0].c_str()), 
			atof(str[1].c_str()), atof(str[2].c_str()), atof(str[3].c_str()));
	}
} CmdCamRotate;

class _CmdCamSetPosition: public Console::Command {
public:
	_CmdCamSetPosition() {
		Name="camsetposition";
		Params.push_back(Console::Param("fX", Console::FLOAT));
		Params.push_back(Console::Param("fY", Console::FLOAT));
		Params.push_back(Console::Param("fZ", Console::FLOAT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		JSApp::Camera.Position[0]=atof(str[0].c_str());
		JSApp::Camera.Position[1]=atof(str[1].c_str());
		JSApp::Camera.Position[2]=atof(str[2].c_str());
	}
} CmdCamSetPosition;

BEGINCOMMAND(partcreatesystem)
ParticleManager::CreateSystem();
ENDCOMMAND(partnewsystem)

BEGINCOMMAND(partenableparticles)
Switch(ParticleManager::UseParticles, "Particles: ");
ENDCOMMAND(partenableparticles)

BEGINCOMMAND(partpointsprites)
Switch(ParticleManager::UsePointSprites, "Point Sprites for Particles: ");
ENDCOMMAND(partpointsprites)

BEGINCOMMAND(partlistsystems)
ParticleManager::ListSystems();
ENDCOMMAND(partlistsystems)

class _CmdInitParticle: public Console::Command {
public:
	_CmdInitParticle() {
		Name="partinitsystem";
		Params.push_back(Console::Param("iSystem", Console::INT));
		Params.push_back(Console::Param("iCount", Console::INT));
		Params.push_back(Console::Param("fLifetime", Console::FLOAT));
		Params.push_back(Console::Param("fSize", Console::FLOAT));
		Params.push_back(Console::Param("sTexture", Console::STRING));
		Params.push_back(Console::Param("fR", Console::FLOAT));
		Params.push_back(Console::Param("fG", Console::FLOAT));
		Params.push_back(Console::Param("fB", Console::FLOAT));
		Params.push_back(Console::Param("fA", Console::FLOAT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		ParticleManager::InitSystem(atoi(str[0].c_str()), atoi(str[1].c_str()),
									atof(str[2].c_str()), atof(str[3].c_str()),
									str[4].c_str(),
									atof(str[5].c_str()), atof(str[6].c_str()),
									atof(str[7].c_str()), atof(str[8].c_str()));
	}
} CmdInitParticle;

class _CmdEnableParticle: public Console::Command {
public:
	_CmdEnableParticle() {
		Name="partenablesystem";
		Params.push_back(Console::Param("iSystem", Console::INT));
		Params.push_back(Console::Param("bEnable", Console::BOOL));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		ParticleManager::EnableSystem(atoi(str[0].c_str()), str[1]=="1");
	}
} CmdEnableParticle;

class _CmdParticleColor: public Console::Command {
public:
	_CmdParticleColor() {
		Name="partsetcolor";
		Params.push_back(Console::Param("iSystem", Console::INT));
		Params.push_back(Console::Param("fR", Console::FLOAT));
		Params.push_back(Console::Param("fG", Console::FLOAT));
		Params.push_back(Console::Param("fB", Console::FLOAT));
		Params.push_back(Console::Param("fA", Console::FLOAT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		ParticleManager::SetParticleColor(atoi(str[0].c_str()),
									atof(str[4].c_str()), atof(str[5].c_str()),
									atof(str[6].c_str()), atof(str[7].c_str()));
	}
} CmdParticleColor;

class _CmdParticleLife: public Console::Command {
public:
	_CmdParticleLife() {
		Name="partsetlifetime";
		Params.push_back(Console::Param("iSystem", Console::INT));
		Params.push_back(Console::Param("fLifetime", Console::FLOAT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		ParticleManager::SetParticleLifetime(atoi(str[0].c_str()), atof(str[1].c_str()));
	}
} CmdParticleLife;

class _CmdDeleteParticleSystem: public Console::Command {
public:
	_CmdDeleteParticleSystem() {
		Name="partdeletesystem";
		Params.push_back(Console::Param("iSystem", Console::INT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		ParticleManager::DeleteSystem(atoi(str[0].c_str()));
	}
} CmdDeleteParticleSystem;

class _CmdParticleSize: public Console::Command {
public:
	_CmdParticleSize() {
		Name="partsetsize";
		Params.push_back(Console::Param("iSystem", Console::INT));
		Params.push_back(Console::Param("fSize", Console::FLOAT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		ParticleManager::SetParticleSize(atoi(str[0].c_str()), atof(str[1].c_str()));
	}
} CmdParticleSize;

class _CmdParticleCount: public Console::Command {
public:
	_CmdParticleCount() {
		Name="partsetamount";
		Params.push_back(Console::Param("iSystem", Console::INT));
		Params.push_back(Console::Param("iCount", Console::INT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		ParticleManager::SetParticleCount(atoi(str[0].c_str()), atoi(str[1].c_str()));
	}
} CmdParticleCount;

class _CmdParticleTexture: public Console::Command {
public:
	_CmdParticleTexture() {
		Name="partsettexture";
		Params.push_back(Console::Param("iSystem", Console::INT));
		Params.push_back(Console::Param("sFilename", Console::STRING));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		ParticleManager::SetParticleTexture(atoi(str[0].c_str()), str[1].c_str());
	}
} CmdParticleTexture;

class _CmdPauseParticle: public Console::Command {
public:
	_CmdPauseParticle() {
		Name="partpausesystem";
		Params.push_back(Console::Param("iSystem", Console::INT));
		Params.push_back(Console::Param("bPause", Console::BOOL));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		ParticleManager::PauseSystem(atoi(str[0].c_str()), str[1]=="1");
	}
} CmdPauseParticle;

class _CmdResetParticle: public Console::Command {
public:
	_CmdResetParticle() {
		Name="partresetsystem";
		Params.push_back(Console::Param("iSystem", Console::INT));
		Params.push_back(Console::Param("bRun", Console::BOOL));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		ParticleManager::ResetSystem(atoi(str[0].c_str()), str[1]=="1");
	}
} CmdResetParticle;

#include "Terrain.h"
extern Terrain* terrain;

BEGINCOMMAND(terdrawwater)
Switch(terrain->DrawWater, "Water");
ENDCOMMAND(terdrawwater)

BEGINCOMMAND(teruselod)
Switch(terrain->UseDynLod, "Dynamic LoD selection");
ENDCOMMAND(teruselod)

BEGINCOMMAND(terloddistance)
Switch(terrain->LodDistanceBased, "Distance based LoD selection");
ENDCOMMAND(terdistancelod)

class _CmdSetLoD:public Console::Command {
public:
	_CmdSetLoD()  {
		Name="tersetlod";
		Params.push_back(Console::Param("iLoD", Console::INT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {terrain->SetLOD(atoi(str[0].c_str()));}
} CmdSetLoD;

class _CmdSetLodStep:public Console::Command {
public:
	_CmdSetLodStep()  {
		Name="tersetlodstep";
		Params.push_back(Console::Param("fLodStep", Console::FLOAT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {terrain->LodStep=atof(str[0].c_str());}
} CmdSetLodStep;

class _CmdSetLoDThres:public Console::Command {
public:
	_CmdSetLoDThres()  {
		Name="tersetthreshold";
		Params.push_back(Console::Param("fLodThreshold", Console::FLOAT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {terrain->SetLoDThreshold(atof(str[0].c_str()));}
} CmdSetLoDThres;

class _CmdSetBaseMap:public Console::Command {
public:
	_CmdSetBaseMap()  {
		Name="tersetbasemap";
		Params.push_back(Console::Param("sFilename", Console::STRING));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		if (terrain) terrain->SetBasemap(str[0].c_str());
	}
} CmdSetBaseMap;

class _CmdLoadMap:public Console::Command {
public:
	_CmdLoadMap()  {
		Name="terloadmap";
		Params.push_back(Console::Param("sFilename", Console::STRING));
		Params.push_back(Console::Param("iMapSize", Console::INT));
		Params.push_back(Console::Param("iPatchSize", Console::INT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		if (!terrain) terrain = new Terrain(JSApp::Camera);
		terrain->LoadHeightmap(str[0].c_str(), atoi(str[1].c_str()), atoi(str[2].c_str()));
	}
} CmdLoadMap;

class _CmdCreateMap:public Console::Command {
public:
	_CmdCreateMap()  {
		Name="tercreatemap";
		Params.push_back(Console::Param("iMapSize", Console::INT));
		Params.push_back(Console::Param("iPatchSize", Console::INT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		if (!terrain) terrain = new Terrain(JSApp::Camera);
		terrain->CreateHeightmap(atoi(str[0].c_str()), atoi(str[1].c_str()));
	}
} CmdCreateMap;

class _CmdScript: public Console::Command {
public:
	_CmdScript() {
		Name="script";
		Params.push_back(Console::Param("sScript", Console::STRING));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		Console::ExecuteScript((str[0]+".csf").c_str());
	}
} CmdScript;

class _CmdFogDens: public Console::Command {
public:
	_CmdFogDens() {
		Name="setfogdensity";
		Params.push_back(Console::Param("fDensity", Console::FLOAT));
		Console::AddCommand(this);
	}
	void Execute(string* str) {glFogf(GL_FOG_DENSITY, atof(str[0].c_str()));}
} CmdFogDens;

class _CmdSetMoveSpeed: public Console::Command {
public:
	_CmdSetMoveSpeed() {
		Name="setmovementspeed";
		Params.push_back(Console::Param("fSpeed", Console::FLOAT));
		Params.push_back(Console::Param("sUnit", Console::STRING));
		Console::AddCommand(this);
	}
	void Execute(string* str) {
		JSApp::SetMoveSpeed(atof(str[0].c_str()), str[1]);
	}
} CmdSetMoveSpeed;

