#ifndef SDLFRAME_INCLUDED
#define SDLFRAME_INCLUDED

#include "OpenGL.h"
#include <map>
#include <string>
#include <vector>
#include "cameraGL.h"
#include "glfont.h"
#include "Timer.h"
#include "ProfileCounter.h"
using namespace std;

struct JSAction {
	string Name;
	unsigned Key;
};

class JSApp {
	static std::vector<JSAction> Mappings;
	static int Mouse_x, Mouse_y, Mouse_z;
	static float MoveSpeed;
	static bool CursorFree;
	static bool ConsoleOpen;
	
	static int ReadConfig();
	static void HandleActions();
	static void ResizeCallback(int widht, int height);
	static void KeyCallback(int key, int state);
	static void MouseBtnCallback(int btn, int state);
	static void MouseMoveCallback(int x, int y);
	static void MouseWheelCallback(int pos);
	
public:
	static CameraGL Camera;
	static map<string, int> Config;
	static RDTimer Timer;
	static int AxisState[3];	
	static float FrameTime;	
	static char KeyState[400];
	static bool Paused;
	static bool Quit;
	static int numTriangles;

	static void Init();
	static void Shutdown();

	static void Tick(bool newFrame=1);
	static unsigned InputToInt(string key);
	static void EnterHUDMode();
	static void LeaveHUDMode();
	static void ShowStats();
	static void SetMoveSpeed(float s, string unit);
};

#endif
