#ifndef LOADER_INCLUDED
#define LOADER_INCLUDED

#include <map>
#include <string>
#include "OpenGL.h"
using namespace std;

enum TYPE {LOT_SHADER, LOT_MESH};

struct RessourceObject {unsigned index, type;};

class Loader {
public:
	static int LoadMesh(const char*);
	static int LoadShader(const char*);
	static void Unload(unsigned idx, unsigned type);
	static void UnloadAll();
	static int LoadShaderObject(int Type, const char* shader);
	static int NewShaderProgram(GLhandleARB vrtShd, GLhandleARB frgShd);

private:
	static map<string, RessourceObject> LoadedObjects;
	Loader();
	
};

#endif
