#ifndef SCQUADTREE_INCLUDED
#define SCQUADTREE_INCLUDED

#include "Console.h"
#include "VectorX.h"
#include "OpenGL.h"
#include "TerrainPatch.h"
#include "Globals.h"

struct SCNode {
	short Px, Py, Pz;
	unsigned short Size;
	unsigned short Height;
	unsigned short Radius;

	void Set(short px, short pz, unsigned short size) {Px=px; Py=0; Pz=pz; Height=0; Size=size;}
};

class SCQuadTree {
public:
	SCNode* Data;
	unsigned numLevels;
	unsigned numNodes;
	unsigned firstLeaf;

	SCQuadTree() : Data(0) {}
	~SCQuadTree() {Clear();}
	void Clear() {SDELETEARY(Data);}
	void Init(unsigned rSize, unsigned LeafSize);
	void UpdateNodesUp(unsigned node, float y, float h);
	unsigned NodeFromPos(float x, float y);
	inline unsigned GetLeaves(unsigned& node) {
		int num=1;
		while (node < firstLeaf) {(node<<=2)++; num<<=2;}
		return num;
	}
	inline void Up(unsigned& node) {(--node)>>=2;}
	inline void Down(unsigned& node) {++(node<<=2);}
};

#endif
