#ifndef TIMER_INCLUDED
#define TIMER_INCLUDED

#include <stdio.h>

class RDTimer {
public:
	static unsigned overhead;
	RDTimer() {Start();}
	void Start() {
		startTime=GetCPUTicks();
	}
	float Reset() {
		unsigned __int64 curtime=GetCPUTicks();
		float seconds=cpuSpeed*(curtime-startTime);
		startTime=curtime;
		return seconds;
	}
	float Peek() {
		unsigned __int64 curtime=GetCPUTicks();
		return cpuSpeed*(curtime-startTime);
	}

	static void Init();
	static volatile inline __int64 GetCPUTicks() {
		__asm cpuid
		__asm rdtsc
	}
	static float cpuSpeed;
private:
	unsigned __int64 startTime;
};

#endif
