#ifndef CAMERAGL_INCLUDED
#define CAMERAGL_INCLUDED

class CameraGL {
public:
	float const *Right, *Up, *Forward;
	float *Position;
	float xFac, yFac;
	float NearP, FarP;
	float FoV;

private:
	float FrustumColor[3];
	float Transform[16];
	float LN[3], RN[3], TN[3], BN[3];
	float BLN[2], BRN[2], BTN[2], BBN[2];
	unsigned ResX, ResY;

public:
	CameraGL(float x=0.0f, float y=0.0f, float z=0.0f);

	void setView();
	void move(float x, float y, float z, bool global=false, float distance=1);	
	void rotate(float deg, float x, float y, float z, bool global=false);

	void setPerspective(unsigned resX, unsigned resY, float fov, float nearp, float farp);
	int SphereVisible(float pos[3], float radius);
	int AltSphereVisible(float pos[3], float radius);
	bool BoxVisible(float bbox[24]);
	bool AABBVisible(float bbox[6]);
	void SetFrustumColor(float r, float g, float b);
	void DrawFrustum(float dist=0);
	void Screen2World(float x, float y, float vec[3]);
	void setViewDistance(float n, float f);
	void setFoV(float fov);
	void reset();
};

#endif

